git-submodule.shon commit convert: treat an empty string for clean/smudge filters as "cat" (1a8630d)
   1#!/bin/sh
   2#
   3# git-submodule.sh: add, init, update or list git submodules
   4#
   5# Copyright (c) 2007 Lars Hjemli
   6
   7dashless=$(basename "$0" | sed -e 's/-/ /')
   8USAGE="[--quiet] add [-b <branch>] [-f|--force] [--name <name>] [--reference <repository>] [--] <repository> [<path>]
   9   or: $dashless [--quiet] status [--cached] [--recursive] [--] [<path>...]
  10   or: $dashless [--quiet] init [--] [<path>...]
  11   or: $dashless [--quiet] deinit [-f|--force] [--] <path>...
  12   or: $dashless [--quiet] update [--init] [--remote] [-N|--no-fetch] [-f|--force] [--checkout|--merge|--rebase] [--reference <repository>] [--recursive] [--] [<path>...]
  13   or: $dashless [--quiet] summary [--cached|--files] [--summary-limit <n>] [commit] [--] [<path>...]
  14   or: $dashless [--quiet] foreach [--recursive] <command>
  15   or: $dashless [--quiet] sync [--recursive] [--] [<path>...]"
  16OPTIONS_SPEC=
  17SUBDIRECTORY_OK=Yes
  18. git-sh-setup
  19. git-sh-i18n
  20. git-parse-remote
  21require_work_tree
  22wt_prefix=$(git rev-parse --show-prefix)
  23cd_to_toplevel
  24
  25# Restrict ourselves to a vanilla subset of protocols; the URLs
  26# we get are under control of a remote repository, and we do not
  27# want them kicking off arbitrary git-remote-* programs.
  28#
  29# If the user has already specified a set of allowed protocols,
  30# we assume they know what they're doing and use that instead.
  31: ${GIT_ALLOW_PROTOCOL=file:git:http:https:ssh}
  32export GIT_ALLOW_PROTOCOL
  33
  34command=
  35branch=
  36force=
  37reference=
  38cached=
  39recursive=
  40init=
  41files=
  42remote=
  43nofetch=
  44update=
  45prefix=
  46custom_name=
  47depth=
  48
  49# The function takes at most 2 arguments. The first argument is the
  50# URL that navigates to the submodule origin repo. When relative, this URL
  51# is relative to the superproject origin URL repo. The second up_path
  52# argument, if specified, is the relative path that navigates
  53# from the submodule working tree to the superproject working tree.
  54#
  55# The output of the function is the origin URL of the submodule.
  56#
  57# The output will either be an absolute URL or filesystem path (if the
  58# superproject origin URL is an absolute URL or filesystem path,
  59# respectively) or a relative file system path (if the superproject
  60# origin URL is a relative file system path).
  61#
  62# When the output is a relative file system path, the path is either
  63# relative to the submodule working tree, if up_path is specified, or to
  64# the superproject working tree otherwise.
  65resolve_relative_url ()
  66{
  67        remote=$(get_default_remote)
  68        remoteurl=$(git config "remote.$remote.url") ||
  69                remoteurl=$(pwd) # the repository is its own authoritative upstream
  70        url="$1"
  71        remoteurl=${remoteurl%/}
  72        sep=/
  73        up_path="$2"
  74
  75        case "$remoteurl" in
  76        *:*|/*)
  77                is_relative=
  78                ;;
  79        ./*|../*)
  80                is_relative=t
  81                ;;
  82        *)
  83                is_relative=t
  84                remoteurl="./$remoteurl"
  85                ;;
  86        esac
  87
  88        while test -n "$url"
  89        do
  90                case "$url" in
  91                ../*)
  92                        url="${url#../}"
  93                        case "$remoteurl" in
  94                        */*)
  95                                remoteurl="${remoteurl%/*}"
  96                                ;;
  97                        *:*)
  98                                remoteurl="${remoteurl%:*}"
  99                                sep=:
 100                                ;;
 101                        *)
 102                                if test -z "$is_relative" || test "." = "$remoteurl"
 103                                then
 104                                        die "$(eval_gettext "cannot strip one component off url '\$remoteurl'")"
 105                                else
 106                                        remoteurl=.
 107                                fi
 108                                ;;
 109                        esac
 110                        ;;
 111                ./*)
 112                        url="${url#./}"
 113                        ;;
 114                *)
 115                        break;;
 116                esac
 117        done
 118        remoteurl="$remoteurl$sep${url%/}"
 119        echo "${is_relative:+${up_path}}${remoteurl#./}"
 120}
 121
 122# Resolve a path to be relative to another path.  This is intended for
 123# converting submodule paths when git-submodule is run in a subdirectory
 124# and only handles paths where the directory separator is '/'.
 125#
 126# The output is the first argument as a path relative to the second argument,
 127# which defaults to $wt_prefix if it is omitted.
 128relative_path ()
 129{
 130        local target curdir result
 131        target=$1
 132        curdir=${2-$wt_prefix}
 133        curdir=${curdir%/}
 134        result=
 135
 136        while test -n "$curdir"
 137        do
 138                case "$target" in
 139                "$curdir/"*)
 140                        target=${target#"$curdir"/}
 141                        break
 142                        ;;
 143                esac
 144
 145                result="${result}../"
 146                if test "$curdir" = "${curdir%/*}"
 147                then
 148                        curdir=
 149                else
 150                        curdir="${curdir%/*}"
 151                fi
 152        done
 153
 154        echo "$result$target"
 155}
 156
 157die_if_unmatched ()
 158{
 159        if test "$1" = "#unmatched"
 160        then
 161                exit 1
 162        fi
 163}
 164
 165#
 166# Print a submodule configuration setting
 167#
 168# $1 = submodule name
 169# $2 = option name
 170# $3 = default value
 171#
 172# Checks in the usual git-config places first (for overrides),
 173# otherwise it falls back on .gitmodules.  This allows you to
 174# distribute project-wide defaults in .gitmodules, while still
 175# customizing individual repositories if necessary.  If the option is
 176# not in .gitmodules either, print a default value.
 177#
 178get_submodule_config () {
 179        name="$1"
 180        option="$2"
 181        default="$3"
 182        value=$(git config submodule."$name"."$option")
 183        if test -z "$value"
 184        then
 185                value=$(git config -f .gitmodules submodule."$name"."$option")
 186        fi
 187        printf '%s' "${value:-$default}"
 188}
 189
 190isnumber()
 191{
 192        n=$(($1 + 0)) 2>/dev/null && test "$n" = "$1"
 193}
 194
 195#
 196# Add a new submodule to the working tree, .gitmodules and the index
 197#
 198# $@ = repo path
 199#
 200# optional branch is stored in global branch variable
 201#
 202cmd_add()
 203{
 204        # parse $args after "submodule ... add".
 205        reference_path=
 206        while test $# -ne 0
 207        do
 208                case "$1" in
 209                -b | --branch)
 210                        case "$2" in '') usage ;; esac
 211                        branch=$2
 212                        shift
 213                        ;;
 214                -f | --force)
 215                        force=$1
 216                        ;;
 217                -q|--quiet)
 218                        GIT_QUIET=1
 219                        ;;
 220                --reference)
 221                        case "$2" in '') usage ;; esac
 222                        reference_path=$2
 223                        shift
 224                        ;;
 225                --reference=*)
 226                        reference_path="${1#--reference=}"
 227                        ;;
 228                --name)
 229                        case "$2" in '') usage ;; esac
 230                        custom_name=$2
 231                        shift
 232                        ;;
 233                --depth)
 234                        case "$2" in '') usage ;; esac
 235                        depth="--depth=$2"
 236                        shift
 237                        ;;
 238                --depth=*)
 239                        depth=$1
 240                        ;;
 241                --)
 242                        shift
 243                        break
 244                        ;;
 245                -*)
 246                        usage
 247                        ;;
 248                *)
 249                        break
 250                        ;;
 251                esac
 252                shift
 253        done
 254
 255        if test -n "$reference_path"
 256        then
 257                is_absolute_path "$reference_path" ||
 258                reference_path="$wt_prefix$reference_path"
 259
 260                reference="--reference=$reference_path"
 261        fi
 262
 263        repo=$1
 264        sm_path=$2
 265
 266        if test -z "$sm_path"; then
 267                sm_path=$(printf '%s\n' "$repo" |
 268                        sed -e 's|/$||' -e 's|:*/*\.git$||' -e 's|.*[/:]||g')
 269        fi
 270
 271        if test -z "$repo" || test -z "$sm_path"; then
 272                usage
 273        fi
 274
 275        is_absolute_path "$sm_path" || sm_path="$wt_prefix$sm_path"
 276
 277        # assure repo is absolute or relative to parent
 278        case "$repo" in
 279        ./*|../*)
 280                test -z "$wt_prefix" ||
 281                die "$(gettext "Relative path can only be used from the toplevel of the working tree")"
 282
 283                # dereference source url relative to parent's url
 284                realrepo=$(resolve_relative_url "$repo") || exit
 285                ;;
 286        *:*|/*)
 287                # absolute url
 288                realrepo=$repo
 289                ;;
 290        *)
 291                die "$(eval_gettext "repo URL: '\$repo' must be absolute or begin with ./|../")"
 292        ;;
 293        esac
 294
 295        # normalize path:
 296        # multiple //; leading ./; /./; /../; trailing /
 297        sm_path=$(printf '%s/\n' "$sm_path" |
 298                sed -e '
 299                        s|//*|/|g
 300                        s|^\(\./\)*||
 301                        s|/\(\./\)*|/|g
 302                        :start
 303                        s|\([^/]*\)/\.\./||
 304                        tstart
 305                        s|/*$||
 306                ')
 307        git ls-files --error-unmatch "$sm_path" > /dev/null 2>&1 &&
 308        die "$(eval_gettext "'\$sm_path' already exists in the index")"
 309
 310        if test -z "$force" && ! git add --dry-run --ignore-missing "$sm_path" > /dev/null 2>&1
 311        then
 312                eval_gettextln "The following path is ignored by one of your .gitignore files:
 313\$sm_path
 314Use -f if you really want to add it." >&2
 315                exit 1
 316        fi
 317
 318        if test -n "$custom_name"
 319        then
 320                sm_name="$custom_name"
 321        else
 322                sm_name="$sm_path"
 323        fi
 324
 325        # perhaps the path exists and is already a git repo, else clone it
 326        if test -e "$sm_path"
 327        then
 328                if test -d "$sm_path"/.git || test -f "$sm_path"/.git
 329                then
 330                        eval_gettextln "Adding existing repo at '\$sm_path' to the index"
 331                else
 332                        die "$(eval_gettext "'\$sm_path' already exists and is not a valid git repo")"
 333                fi
 334
 335        else
 336                if test -d ".git/modules/$sm_name"
 337                then
 338                        if test -z "$force"
 339                        then
 340                                echo >&2 "$(eval_gettext "A git directory for '\$sm_name' is found locally with remote(s):")"
 341                                GIT_DIR=".git/modules/$sm_name" GIT_WORK_TREE=. git remote -v | grep '(fetch)' | sed -e s,^,"  ", -e s,' (fetch)',, >&2
 342                                echo >&2 "$(eval_gettext "If you want to reuse this local git directory instead of cloning again from")"
 343                                echo >&2 "  $realrepo"
 344                                echo >&2 "$(eval_gettext "use the '--force' option. If the local git directory is not the correct repo")"
 345                                die "$(eval_gettext "or you are unsure what this means choose another name with the '--name' option.")"
 346                        else
 347                                echo "$(eval_gettext "Reactivating local git directory for submodule '\$sm_name'.")"
 348                        fi
 349                fi
 350                git submodule--helper clone ${GIT_QUIET:+--quiet} --prefix "$wt_prefix" --path "$sm_path" --name "$sm_name" --url "$realrepo" "$reference" "$depth" || exit
 351                (
 352                        clear_local_git_env
 353                        cd "$sm_path" &&
 354                        # ash fails to wordsplit ${branch:+-b "$branch"...}
 355                        case "$branch" in
 356                        '') git checkout -f -q ;;
 357                        ?*) git checkout -f -q -B "$branch" "origin/$branch" ;;
 358                        esac
 359                ) || die "$(eval_gettext "Unable to checkout submodule '\$sm_path'")"
 360        fi
 361        git config submodule."$sm_name".url "$realrepo"
 362
 363        git add $force "$sm_path" ||
 364        die "$(eval_gettext "Failed to add submodule '\$sm_path'")"
 365
 366        git config -f .gitmodules submodule."$sm_name".path "$sm_path" &&
 367        git config -f .gitmodules submodule."$sm_name".url "$repo" &&
 368        if test -n "$branch"
 369        then
 370                git config -f .gitmodules submodule."$sm_name".branch "$branch"
 371        fi &&
 372        git add --force .gitmodules ||
 373        die "$(eval_gettext "Failed to register submodule '\$sm_path'")"
 374}
 375
 376#
 377# Execute an arbitrary command sequence in each checked out
 378# submodule
 379#
 380# $@ = command to execute
 381#
 382cmd_foreach()
 383{
 384        # parse $args after "submodule ... foreach".
 385        while test $# -ne 0
 386        do
 387                case "$1" in
 388                -q|--quiet)
 389                        GIT_QUIET=1
 390                        ;;
 391                --recursive)
 392                        recursive=1
 393                        ;;
 394                -*)
 395                        usage
 396                        ;;
 397                *)
 398                        break
 399                        ;;
 400                esac
 401                shift
 402        done
 403
 404        toplevel=$(pwd)
 405
 406        # dup stdin so that it can be restored when running the external
 407        # command in the subshell (and a recursive call to this function)
 408        exec 3<&0
 409
 410        git submodule--helper list --prefix "$wt_prefix"|
 411        while read mode sha1 stage sm_path
 412        do
 413                die_if_unmatched "$mode"
 414                if test -e "$sm_path"/.git
 415                then
 416                        displaypath=$(relative_path "$sm_path")
 417                        say "$(eval_gettext "Entering '\$prefix\$displaypath'")"
 418                        name=$(git submodule--helper name "$sm_path")
 419                        (
 420                                prefix="$prefix$sm_path/"
 421                                clear_local_git_env
 422                                cd "$sm_path" &&
 423                                sm_path=$(relative_path "$sm_path") &&
 424                                # we make $path available to scripts ...
 425                                path=$sm_path &&
 426                                if test $# -eq 1
 427                                then
 428                                        eval "$1"
 429                                else
 430                                        "$@"
 431                                fi &&
 432                                if test -n "$recursive"
 433                                then
 434                                        cmd_foreach "--recursive" "$@"
 435                                fi
 436                        ) <&3 3<&- ||
 437                        die "$(eval_gettext "Stopping at '\$prefix\$displaypath'; script returned non-zero status.")"
 438                fi
 439        done
 440}
 441
 442#
 443# Register submodules in .git/config
 444#
 445# $@ = requested paths (default to all)
 446#
 447cmd_init()
 448{
 449        # parse $args after "submodule ... init".
 450        while test $# -ne 0
 451        do
 452                case "$1" in
 453                -q|--quiet)
 454                        GIT_QUIET=1
 455                        ;;
 456                --)
 457                        shift
 458                        break
 459                        ;;
 460                -*)
 461                        usage
 462                        ;;
 463                *)
 464                        break
 465                        ;;
 466                esac
 467                shift
 468        done
 469
 470        git submodule--helper list --prefix "$wt_prefix" "$@" |
 471        while read mode sha1 stage sm_path
 472        do
 473                die_if_unmatched "$mode"
 474                name=$(git submodule--helper name "$sm_path") || exit
 475
 476                displaypath=$(relative_path "$sm_path")
 477
 478                # Copy url setting when it is not set yet
 479                if test -z "$(git config "submodule.$name.url")"
 480                then
 481                        url=$(git config -f .gitmodules submodule."$name".url)
 482                        test -z "$url" &&
 483                        die "$(eval_gettext "No url found for submodule path '\$displaypath' in .gitmodules")"
 484
 485                        # Possibly a url relative to parent
 486                        case "$url" in
 487                        ./*|../*)
 488                                url=$(resolve_relative_url "$url") || exit
 489                                ;;
 490                        esac
 491                        git config submodule."$name".url "$url" ||
 492                        die "$(eval_gettext "Failed to register url for submodule path '\$displaypath'")"
 493
 494                        say "$(eval_gettext "Submodule '\$name' (\$url) registered for path '\$displaypath'")"
 495                fi
 496
 497                # Copy "update" setting when it is not set yet
 498                if upd="$(git config -f .gitmodules submodule."$name".update)" &&
 499                   test -n "$upd" &&
 500                   test -z "$(git config submodule."$name".update)"
 501                then
 502                        case "$upd" in
 503                        checkout | rebase | merge | none)
 504                                ;; # known modes of updating
 505                        *)
 506                                echo >&2 "warning: unknown update mode '$upd' suggested for submodule '$name'"
 507                                upd=none
 508                                ;;
 509                        esac
 510                        git config submodule."$name".update "$upd" ||
 511                        die "$(eval_gettext "Failed to register update mode for submodule path '\$displaypath'")"
 512                fi
 513        done
 514}
 515
 516#
 517# Unregister submodules from .git/config and remove their work tree
 518#
 519# $@ = requested paths (use '.' to deinit all submodules)
 520#
 521cmd_deinit()
 522{
 523        # parse $args after "submodule ... deinit".
 524        while test $# -ne 0
 525        do
 526                case "$1" in
 527                -f|--force)
 528                        force=$1
 529                        ;;
 530                -q|--quiet)
 531                        GIT_QUIET=1
 532                        ;;
 533                --)
 534                        shift
 535                        break
 536                        ;;
 537                -*)
 538                        usage
 539                        ;;
 540                *)
 541                        break
 542                        ;;
 543                esac
 544                shift
 545        done
 546
 547        if test $# = 0
 548        then
 549                die "$(eval_gettext "Use '.' if you really want to deinitialize all submodules")"
 550        fi
 551
 552        git submodule--helper list --prefix "$wt_prefix" "$@" |
 553        while read mode sha1 stage sm_path
 554        do
 555                die_if_unmatched "$mode"
 556                name=$(git submodule--helper name "$sm_path") || exit
 557
 558                displaypath=$(relative_path "$sm_path")
 559
 560                # Remove the submodule work tree (unless the user already did it)
 561                if test -d "$sm_path"
 562                then
 563                        # Protect submodules containing a .git directory
 564                        if test -d "$sm_path/.git"
 565                        then
 566                                echo >&2 "$(eval_gettext "Submodule work tree '\$displaypath' contains a .git directory")"
 567                                die "$(eval_gettext "(use 'rm -rf' if you really want to remove it including all of its history)")"
 568                        fi
 569
 570                        if test -z "$force"
 571                        then
 572                                git rm -qn "$sm_path" ||
 573                                die "$(eval_gettext "Submodule work tree '\$displaypath' contains local modifications; use '-f' to discard them")"
 574                        fi
 575                        rm -rf "$sm_path" &&
 576                        say "$(eval_gettext "Cleared directory '\$displaypath'")" ||
 577                        say "$(eval_gettext "Could not remove submodule work tree '\$displaypath'")"
 578                fi
 579
 580                mkdir "$sm_path" || say "$(eval_gettext "Could not create empty submodule directory '\$displaypath'")"
 581
 582                # Remove the .git/config entries (unless the user already did it)
 583                if test -n "$(git config --get-regexp submodule."$name\.")"
 584                then
 585                        # Remove the whole section so we have a clean state when
 586                        # the user later decides to init this submodule again
 587                        url=$(git config submodule."$name".url)
 588                        git config --remove-section submodule."$name" 2>/dev/null &&
 589                        say "$(eval_gettext "Submodule '\$name' (\$url) unregistered for path '\$displaypath'")"
 590                fi
 591        done
 592}
 593
 594#
 595# Update each submodule path to correct revision, using clone and checkout as needed
 596#
 597# $@ = requested paths (default to all)
 598#
 599cmd_update()
 600{
 601        # parse $args after "submodule ... update".
 602        while test $# -ne 0
 603        do
 604                case "$1" in
 605                -q|--quiet)
 606                        GIT_QUIET=1
 607                        ;;
 608                -i|--init)
 609                        init=1
 610                        ;;
 611                --remote)
 612                        remote=1
 613                        ;;
 614                -N|--no-fetch)
 615                        nofetch=1
 616                        ;;
 617                -f|--force)
 618                        force=$1
 619                        ;;
 620                -r|--rebase)
 621                        update="rebase"
 622                        ;;
 623                --reference)
 624                        case "$2" in '') usage ;; esac
 625                        reference="--reference=$2"
 626                        shift
 627                        ;;
 628                --reference=*)
 629                        reference="$1"
 630                        ;;
 631                -m|--merge)
 632                        update="merge"
 633                        ;;
 634                --recursive)
 635                        recursive=1
 636                        ;;
 637                --checkout)
 638                        update="checkout"
 639                        ;;
 640                --depth)
 641                        case "$2" in '') usage ;; esac
 642                        depth="--depth=$2"
 643                        shift
 644                        ;;
 645                --depth=*)
 646                        depth=$1
 647                        ;;
 648                --)
 649                        shift
 650                        break
 651                        ;;
 652                -*)
 653                        usage
 654                        ;;
 655                *)
 656                        break
 657                        ;;
 658                esac
 659                shift
 660        done
 661
 662        if test -n "$init"
 663        then
 664                cmd_init "--" "$@" || return
 665        fi
 666
 667        cloned_modules=
 668        git submodule--helper list --prefix "$wt_prefix" "$@" | {
 669        err=
 670        while read mode sha1 stage sm_path
 671        do
 672                die_if_unmatched "$mode"
 673                if test "$stage" = U
 674                then
 675                        echo >&2 "Skipping unmerged submodule $prefix$sm_path"
 676                        continue
 677                fi
 678                name=$(git submodule--helper name "$sm_path") || exit
 679                url=$(git config submodule."$name".url)
 680                branch=$(get_submodule_config "$name" branch master)
 681                if ! test -z "$update"
 682                then
 683                        update_module=$update
 684                else
 685                        update_module=$(git config submodule."$name".update)
 686                        if test -z "$update_module"
 687                        then
 688                                update_module="checkout"
 689                        fi
 690                fi
 691
 692                displaypath=$(relative_path "$prefix$sm_path")
 693
 694                if test "$update_module" = "none"
 695                then
 696                        echo "Skipping submodule '$displaypath'"
 697                        continue
 698                fi
 699
 700                if test -z "$url"
 701                then
 702                        # Only mention uninitialized submodules when its
 703                        # path have been specified
 704                        test "$#" != "0" &&
 705                        say "$(eval_gettext "Submodule path '\$displaypath' not initialized
 706Maybe you want to use 'update --init'?")"
 707                        continue
 708                fi
 709
 710                if ! test -d "$sm_path"/.git && ! test -f "$sm_path"/.git
 711                then
 712                        git submodule--helper clone ${GIT_QUIET:+--quiet} --prefix "$prefix" --path "$sm_path" --name "$name" --url "$url" "$reference" "$depth" || exit
 713                        cloned_modules="$cloned_modules;$name"
 714                        subsha1=
 715                else
 716                        subsha1=$(clear_local_git_env; cd "$sm_path" &&
 717                                git rev-parse --verify HEAD) ||
 718                        die "$(eval_gettext "Unable to find current revision in submodule path '\$displaypath'")"
 719                fi
 720
 721                if test -n "$remote"
 722                then
 723                        if test -z "$nofetch"
 724                        then
 725                                # Fetch remote before determining tracking $sha1
 726                                (clear_local_git_env; cd "$sm_path" && git-fetch) ||
 727                                die "$(eval_gettext "Unable to fetch in submodule path '\$sm_path'")"
 728                        fi
 729                        remote_name=$(clear_local_git_env; cd "$sm_path" && get_default_remote)
 730                        sha1=$(clear_local_git_env; cd "$sm_path" &&
 731                                git rev-parse --verify "${remote_name}/${branch}") ||
 732                        die "$(eval_gettext "Unable to find current ${remote_name}/${branch} revision in submodule path '\$sm_path'")"
 733                fi
 734
 735                if test "$subsha1" != "$sha1" || test -n "$force"
 736                then
 737                        subforce=$force
 738                        # If we don't already have a -f flag and the submodule has never been checked out
 739                        if test -z "$subsha1" && test -z "$force"
 740                        then
 741                                subforce="-f"
 742                        fi
 743
 744                        if test -z "$nofetch"
 745                        then
 746                                # Run fetch only if $sha1 isn't present or it
 747                                # is not reachable from a ref.
 748                                (clear_local_git_env; cd "$sm_path" &&
 749                                        ( (rev=$(git rev-list -n 1 $sha1 --not --all 2>/dev/null) &&
 750                                         test -z "$rev") || git-fetch)) ||
 751                                die "$(eval_gettext "Unable to fetch in submodule path '\$displaypath'")"
 752                        fi
 753
 754                        # Is this something we just cloned?
 755                        case ";$cloned_modules;" in
 756                        *";$name;"*)
 757                                # then there is no local change to integrate
 758                                update_module=checkout ;;
 759                        esac
 760
 761                        must_die_on_failure=
 762                        case "$update_module" in
 763                        checkout)
 764                                command="git checkout $subforce -q"
 765                                die_msg="$(eval_gettext "Unable to checkout '\$sha1' in submodule path '\$displaypath'")"
 766                                say_msg="$(eval_gettext "Submodule path '\$displaypath': checked out '\$sha1'")"
 767                                ;;
 768                        rebase)
 769                                command="git rebase"
 770                                die_msg="$(eval_gettext "Unable to rebase '\$sha1' in submodule path '\$displaypath'")"
 771                                say_msg="$(eval_gettext "Submodule path '\$displaypath': rebased into '\$sha1'")"
 772                                must_die_on_failure=yes
 773                                ;;
 774                        merge)
 775                                command="git merge"
 776                                die_msg="$(eval_gettext "Unable to merge '\$sha1' in submodule path '\$displaypath'")"
 777                                say_msg="$(eval_gettext "Submodule path '\$displaypath': merged in '\$sha1'")"
 778                                must_die_on_failure=yes
 779                                ;;
 780                        !*)
 781                                command="${update_module#!}"
 782                                die_msg="$(eval_gettext "Execution of '\$command \$sha1' failed in submodule path '\$prefix\$sm_path'")"
 783                                say_msg="$(eval_gettext "Submodule path '\$prefix\$sm_path': '\$command \$sha1'")"
 784                                must_die_on_failure=yes
 785                                ;;
 786                        *)
 787                                die "$(eval_gettext "Invalid update mode '$update_module' for submodule '$name'")"
 788                        esac
 789
 790                        if (clear_local_git_env; cd "$sm_path" && $command "$sha1")
 791                        then
 792                                say "$say_msg"
 793                        elif test -n "$must_die_on_failure"
 794                        then
 795                                die_with_status 2 "$die_msg"
 796                        else
 797                                err="${err};$die_msg"
 798                                continue
 799                        fi
 800                fi
 801
 802                if test -n "$recursive"
 803                then
 804                        (
 805                                prefix="$prefix$sm_path/"
 806                                clear_local_git_env
 807                                cd "$sm_path" &&
 808                                eval cmd_update
 809                        )
 810                        res=$?
 811                        if test $res -gt 0
 812                        then
 813                                die_msg="$(eval_gettext "Failed to recurse into submodule path '\$displaypath'")"
 814                                if test $res -eq 1
 815                                then
 816                                        err="${err};$die_msg"
 817                                        continue
 818                                else
 819                                        die_with_status $res "$die_msg"
 820                                fi
 821                        fi
 822                fi
 823        done
 824
 825        if test -n "$err"
 826        then
 827                OIFS=$IFS
 828                IFS=';'
 829                for e in $err
 830                do
 831                        if test -n "$e"
 832                        then
 833                                echo >&2 "$e"
 834                        fi
 835                done
 836                IFS=$OIFS
 837                exit 1
 838        fi
 839        }
 840}
 841
 842set_name_rev () {
 843        revname=$( (
 844                clear_local_git_env
 845                cd "$1" && {
 846                        git describe "$2" 2>/dev/null ||
 847                        git describe --tags "$2" 2>/dev/null ||
 848                        git describe --contains "$2" 2>/dev/null ||
 849                        git describe --all --always "$2"
 850                }
 851        ) )
 852        test -z "$revname" || revname=" ($revname)"
 853}
 854#
 855# Show commit summary for submodules in index or working tree
 856#
 857# If '--cached' is given, show summary between index and given commit,
 858# or between working tree and given commit
 859#
 860# $@ = [commit (default 'HEAD'),] requested paths (default all)
 861#
 862cmd_summary() {
 863        summary_limit=-1
 864        for_status=
 865        diff_cmd=diff-index
 866
 867        # parse $args after "submodule ... summary".
 868        while test $# -ne 0
 869        do
 870                case "$1" in
 871                --cached)
 872                        cached="$1"
 873                        ;;
 874                --files)
 875                        files="$1"
 876                        ;;
 877                --for-status)
 878                        for_status="$1"
 879                        ;;
 880                -n|--summary-limit)
 881                        summary_limit="$2"
 882                        isnumber "$summary_limit" || usage
 883                        shift
 884                        ;;
 885                --summary-limit=*)
 886                        summary_limit="${1#--summary-limit=}"
 887                        isnumber "$summary_limit" || usage
 888                        ;;
 889                --)
 890                        shift
 891                        break
 892                        ;;
 893                -*)
 894                        usage
 895                        ;;
 896                *)
 897                        break
 898                        ;;
 899                esac
 900                shift
 901        done
 902
 903        test $summary_limit = 0 && return
 904
 905        if rev=$(git rev-parse -q --verify --default HEAD ${1+"$1"})
 906        then
 907                head=$rev
 908                test $# = 0 || shift
 909        elif test -z "$1" || test "$1" = "HEAD"
 910        then
 911                # before the first commit: compare with an empty tree
 912                head=$(git hash-object -w -t tree --stdin </dev/null)
 913                test -z "$1" || shift
 914        else
 915                head="HEAD"
 916        fi
 917
 918        if [ -n "$files" ]
 919        then
 920                test -n "$cached" &&
 921                die "$(gettext "The --cached option cannot be used with the --files option")"
 922                diff_cmd=diff-files
 923                head=
 924        fi
 925
 926        cd_to_toplevel
 927        eval "set $(git rev-parse --sq --prefix "$wt_prefix" -- "$@")"
 928        # Get modified modules cared by user
 929        modules=$(git $diff_cmd $cached --ignore-submodules=dirty --raw $head -- "$@" |
 930                sane_egrep '^:([0-7]* )?160000' |
 931                while read mod_src mod_dst sha1_src sha1_dst status sm_path
 932                do
 933                        # Always show modules deleted or type-changed (blob<->module)
 934                        if test "$status" = D || test "$status" = T
 935                        then
 936                                printf '%s\n' "$sm_path"
 937                                continue
 938                        fi
 939                        # Respect the ignore setting for --for-status.
 940                        if test -n "$for_status"
 941                        then
 942                                name=$(git submodule--helper name "$sm_path")
 943                                ignore_config=$(get_submodule_config "$name" ignore none)
 944                                test $status != A && test $ignore_config = all && continue
 945                        fi
 946                        # Also show added or modified modules which are checked out
 947                        GIT_DIR="$sm_path/.git" git-rev-parse --git-dir >/dev/null 2>&1 &&
 948                        printf '%s\n' "$sm_path"
 949                done
 950        )
 951
 952        test -z "$modules" && return
 953
 954        git $diff_cmd $cached --ignore-submodules=dirty --raw $head -- $modules |
 955        sane_egrep '^:([0-7]* )?160000' |
 956        cut -c2- |
 957        while read mod_src mod_dst sha1_src sha1_dst status name
 958        do
 959                if test -z "$cached" &&
 960                        test $sha1_dst = 0000000000000000000000000000000000000000
 961                then
 962                        case "$mod_dst" in
 963                        160000)
 964                                sha1_dst=$(GIT_DIR="$name/.git" git rev-parse HEAD)
 965                                ;;
 966                        100644 | 100755 | 120000)
 967                                sha1_dst=$(git hash-object $name)
 968                                ;;
 969                        000000)
 970                                ;; # removed
 971                        *)
 972                                # unexpected type
 973                                eval_gettextln "unexpected mode \$mod_dst" >&2
 974                                continue ;;
 975                        esac
 976                fi
 977                missing_src=
 978                missing_dst=
 979
 980                test $mod_src = 160000 &&
 981                ! GIT_DIR="$name/.git" git-rev-parse -q --verify $sha1_src^0 >/dev/null &&
 982                missing_src=t
 983
 984                test $mod_dst = 160000 &&
 985                ! GIT_DIR="$name/.git" git-rev-parse -q --verify $sha1_dst^0 >/dev/null &&
 986                missing_dst=t
 987
 988                display_name=$(relative_path "$name")
 989
 990                total_commits=
 991                case "$missing_src,$missing_dst" in
 992                t,)
 993                        errmsg="$(eval_gettext "  Warn: \$display_name doesn't contain commit \$sha1_src")"
 994                        ;;
 995                ,t)
 996                        errmsg="$(eval_gettext "  Warn: \$display_name doesn't contain commit \$sha1_dst")"
 997                        ;;
 998                t,t)
 999                        errmsg="$(eval_gettext "  Warn: \$display_name doesn't contain commits \$sha1_src and \$sha1_dst")"
1000                        ;;
1001                *)
1002                        errmsg=
1003                        total_commits=$(
1004                        if test $mod_src = 160000 && test $mod_dst = 160000
1005                        then
1006                                range="$sha1_src...$sha1_dst"
1007                        elif test $mod_src = 160000
1008                        then
1009                                range=$sha1_src
1010                        else
1011                                range=$sha1_dst
1012                        fi
1013                        GIT_DIR="$name/.git" \
1014                        git rev-list --first-parent $range -- | wc -l
1015                        )
1016                        total_commits=" ($(($total_commits + 0)))"
1017                        ;;
1018                esac
1019
1020                sha1_abbr_src=$(echo $sha1_src | cut -c1-7)
1021                sha1_abbr_dst=$(echo $sha1_dst | cut -c1-7)
1022                if test $status = T
1023                then
1024                        blob="$(gettext "blob")"
1025                        submodule="$(gettext "submodule")"
1026                        if test $mod_dst = 160000
1027                        then
1028                                echo "* $display_name $sha1_abbr_src($blob)->$sha1_abbr_dst($submodule)$total_commits:"
1029                        else
1030                                echo "* $display_name $sha1_abbr_src($submodule)->$sha1_abbr_dst($blob)$total_commits:"
1031                        fi
1032                else
1033                        echo "* $display_name $sha1_abbr_src...$sha1_abbr_dst$total_commits:"
1034                fi
1035                if test -n "$errmsg"
1036                then
1037                        # Don't give error msg for modification whose dst is not submodule
1038                        # i.e. deleted or changed to blob
1039                        test $mod_dst = 160000 && echo "$errmsg"
1040                else
1041                        if test $mod_src = 160000 && test $mod_dst = 160000
1042                        then
1043                                limit=
1044                                test $summary_limit -gt 0 && limit="-$summary_limit"
1045                                GIT_DIR="$name/.git" \
1046                                git log $limit --pretty='format:  %m %s' \
1047                                --first-parent $sha1_src...$sha1_dst
1048                        elif test $mod_dst = 160000
1049                        then
1050                                GIT_DIR="$name/.git" \
1051                                git log --pretty='format:  > %s' -1 $sha1_dst
1052                        else
1053                                GIT_DIR="$name/.git" \
1054                                git log --pretty='format:  < %s' -1 $sha1_src
1055                        fi
1056                        echo
1057                fi
1058                echo
1059        done
1060}
1061#
1062# List all submodules, prefixed with:
1063#  - submodule not initialized
1064#  + different revision checked out
1065#
1066# If --cached was specified the revision in the index will be printed
1067# instead of the currently checked out revision.
1068#
1069# $@ = requested paths (default to all)
1070#
1071cmd_status()
1072{
1073        # parse $args after "submodule ... status".
1074        while test $# -ne 0
1075        do
1076                case "$1" in
1077                -q|--quiet)
1078                        GIT_QUIET=1
1079                        ;;
1080                --cached)
1081                        cached=1
1082                        ;;
1083                --recursive)
1084                        recursive=1
1085                        ;;
1086                --)
1087                        shift
1088                        break
1089                        ;;
1090                -*)
1091                        usage
1092                        ;;
1093                *)
1094                        break
1095                        ;;
1096                esac
1097                shift
1098        done
1099
1100        git submodule--helper list --prefix "$wt_prefix" "$@" |
1101        while read mode sha1 stage sm_path
1102        do
1103                die_if_unmatched "$mode"
1104                name=$(git submodule--helper name "$sm_path") || exit
1105                url=$(git config submodule."$name".url)
1106                displaypath=$(relative_path "$prefix$sm_path")
1107                if test "$stage" = U
1108                then
1109                        say "U$sha1 $displaypath"
1110                        continue
1111                fi
1112                if test -z "$url" ||
1113                {
1114                        ! test -d "$sm_path"/.git &&
1115                        ! test -f "$sm_path"/.git
1116                }
1117                then
1118                        say "-$sha1 $displaypath"
1119                        continue;
1120                fi
1121                if git diff-files --ignore-submodules=dirty --quiet -- "$sm_path"
1122                then
1123                        set_name_rev "$sm_path" "$sha1"
1124                        say " $sha1 $displaypath$revname"
1125                else
1126                        if test -z "$cached"
1127                        then
1128                                sha1=$(clear_local_git_env; cd "$sm_path" && git rev-parse --verify HEAD)
1129                        fi
1130                        set_name_rev "$sm_path" "$sha1"
1131                        say "+$sha1 $displaypath$revname"
1132                fi
1133
1134                if test -n "$recursive"
1135                then
1136                        (
1137                                prefix="$displaypath/"
1138                                clear_local_git_env
1139                                cd "$sm_path" &&
1140                                eval cmd_status
1141                        ) ||
1142                        die "$(eval_gettext "Failed to recurse into submodule path '\$sm_path'")"
1143                fi
1144        done
1145}
1146#
1147# Sync remote urls for submodules
1148# This makes the value for remote.$remote.url match the value
1149# specified in .gitmodules.
1150#
1151cmd_sync()
1152{
1153        while test $# -ne 0
1154        do
1155                case "$1" in
1156                -q|--quiet)
1157                        GIT_QUIET=1
1158                        shift
1159                        ;;
1160                --recursive)
1161                        recursive=1
1162                        shift
1163                        ;;
1164                --)
1165                        shift
1166                        break
1167                        ;;
1168                -*)
1169                        usage
1170                        ;;
1171                *)
1172                        break
1173                        ;;
1174                esac
1175        done
1176        cd_to_toplevel
1177        git submodule--helper list --prefix "$wt_prefix" "$@" |
1178        while read mode sha1 stage sm_path
1179        do
1180                die_if_unmatched "$mode"
1181                name=$(git submodule--helper name "$sm_path")
1182                url=$(git config -f .gitmodules --get submodule."$name".url)
1183
1184                # Possibly a url relative to parent
1185                case "$url" in
1186                ./*|../*)
1187                        # rewrite foo/bar as ../.. to find path from
1188                        # submodule work tree to superproject work tree
1189                        up_path="$(printf '%s\n' "$sm_path" | sed "s/[^/][^/]*/../g")" &&
1190                        # guarantee a trailing /
1191                        up_path=${up_path%/}/ &&
1192                        # path from submodule work tree to submodule origin repo
1193                        sub_origin_url=$(resolve_relative_url "$url" "$up_path") &&
1194                        # path from superproject work tree to submodule origin repo
1195                        super_config_url=$(resolve_relative_url "$url") || exit
1196                        ;;
1197                *)
1198                        sub_origin_url="$url"
1199                        super_config_url="$url"
1200                        ;;
1201                esac
1202
1203                if git config "submodule.$name.url" >/dev/null 2>/dev/null
1204                then
1205                        displaypath=$(relative_path "$prefix$sm_path")
1206                        say "$(eval_gettext "Synchronizing submodule url for '\$displaypath'")"
1207                        git config submodule."$name".url "$super_config_url"
1208
1209                        if test -e "$sm_path"/.git
1210                        then
1211                        (
1212                                clear_local_git_env
1213                                cd "$sm_path"
1214                                remote=$(get_default_remote)
1215                                git config remote."$remote".url "$sub_origin_url"
1216
1217                                if test -n "$recursive"
1218                                then
1219                                        prefix="$prefix$sm_path/"
1220                                        eval cmd_sync
1221                                fi
1222                        )
1223                        fi
1224                fi
1225        done
1226}
1227
1228# This loop parses the command line arguments to find the
1229# subcommand name to dispatch.  Parsing of the subcommand specific
1230# options are primarily done by the subcommand implementations.
1231# Subcommand specific options such as --branch and --cached are
1232# parsed here as well, for backward compatibility.
1233
1234while test $# != 0 && test -z "$command"
1235do
1236        case "$1" in
1237        add | foreach | init | deinit | update | status | summary | sync)
1238                command=$1
1239                ;;
1240        -q|--quiet)
1241                GIT_QUIET=1
1242                ;;
1243        -b|--branch)
1244                case "$2" in
1245                '')
1246                        usage
1247                        ;;
1248                esac
1249                branch="$2"; shift
1250                ;;
1251        --cached)
1252                cached="$1"
1253                ;;
1254        --)
1255                break
1256                ;;
1257        -*)
1258                usage
1259                ;;
1260        *)
1261                break
1262                ;;
1263        esac
1264        shift
1265done
1266
1267# No command word defaults to "status"
1268if test -z "$command"
1269then
1270    if test $# = 0
1271    then
1272        command=status
1273    else
1274        usage
1275    fi
1276fi
1277
1278# "-b branch" is accepted only by "add"
1279if test -n "$branch" && test "$command" != add
1280then
1281        usage
1282fi
1283
1284# "--cached" is accepted only by "status" and "summary"
1285if test -n "$cached" && test "$command" != status && test "$command" != summary
1286then
1287        usage
1288fi
1289
1290"cmd_$command" "$@"